<?php
$HEADER = <<<EOF
<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html>
EOF;
$FOOTER = <<<EOF
<hr />
<div><p>
Scoring system for the CC CAMP 07 CTF (C) 2007, Christian Esperer. hc at hcespererdotorg
</p></div>
</div></div>
</body>
</html>
EOF;

	header('Content-Type: text/html');

	if (array_key_exists('page', $_GET)) {
		$PAGE = $_GET['page'];
	} else {
		$PAGE = 'index';
	}

	$PAGE = $argv[2];
	$HOST = $argv[1];

	$db = pg_connect("host=$HOST dbname=ctf user=ctf password=ctfIScool");

	
	$TITLE = 'Camp 07 CTF';
	if ($PAGE == 'index') {
		$CONTENT = '<h2>Scoring table</h2><div>';
		pg_query("begin");
		$query = "select uid,team_name,team_points_offensive,team_points_defensive,team_points_hacking,team_points_advisories from teams";
		$res = pg_query($query);
		$off_max = 1;
		$def_max = 1;
		$adv_max = 1;
		$hak_max = 1;
		while($team = pg_fetch_object($res)) {
			if ($off_max < $team->team_points_offensive) {
				$off_max = $team->team_points_offensive;
			}
			if ($def_max < $team->team_points_defensive) {
				$def_max = $team->team_points_defensive;
			}
			if ($adv_max < $team->team_points_advisories) {
				$adv_max = $team->team_points_advisories;
			}
			if ($hak_max < $team->team_points_hacking) {
				$hak_max = $team->team_points_hacking;
			}
		}

		$tot_max = 1;
		$res = pg_query($query);
		while($team = pg_fetch_object($res)) {
			$t_o = (int) ($team->team_points_offensive * 100 / $off_max);
			$t_d = (int) ($team->team_points_defensive * 100 / $def_max);
			$t_a = (int) ($team->team_points_advisories * 100 / $adv_max);
			$t_h = (int) ($team->team_points_hacking * 100 / $hak_max);
			$t_t = $t_o + $t_d + $t_a + $t_h;
			if ($tot_max < $t_t) {
				$tot_max = $t_t;
			}	
		}

		$res = pg_query($query);
		$t_entries = array();
		$t_data = array();
		while($team = pg_fetch_object($res)) {
			$t_n = $team->team_name . " (#" . $team->uid . ")";
			$t_o = (int) ($team->team_points_offensive * 100 / $off_max);
			$t_d = (int) ($team->team_points_defensive * 100 / $def_max);
			$t_a = (int) ($team->team_points_advisories * 100 / $adv_max);
			$t_h = (int) ($team->team_points_hacking * 100 / $hak_max);
			$t_t = (int) (($t_o + $t_d + $t_a + $t_h) * 100 / $tot_max);
			$t_entries[$t_n] = $t_t;
			$t_data[$t_n] = array($t_o, $t_d, $t_a, $t_h, $t_t);
		}
		arsort($t_entries);
		$TABLE = "<table><tr><th>Rank</th><th>Team name</th><th>Offensive rank</th><th>Defensive rank</th><th>Advisory rank</th><th>Hacking rank</th><th>Total</th></tr>";
		$i = 0;
		foreach($t_entries as $t_n => $t_t) {
			$i++;
			$t_etr = $t_data[$t_n];
			$t_o = $t_etr[0];
			$t_d = $t_etr[1];
			$t_a = $t_etr[2];
			$t_h = $t_etr[3];
			$TABLE .= "<tr><td>$i</td><td>$t_n</td><td>$t_o</td><td>$t_d</td><td>$t_a</td><td>$t_h</td><td>$t_t</td></tr>";
		}
		$TABLE .= "</table>";
		$CONTENT .= $TABLE;
		pg_query("commit");	

	} else if ($PAGE == 'adv') {
		$TABLE = "<table><tr><th>Reporting time</th><th>Team</th><th>Description</th><th>State</th></tr>";
		$res = pg_query("select * from advisories order by advisory_time desc");
		while($entry = pg_fetch_object($res)) {
			$a_ti = $entry->advisory_time;
			$a_te = htmlentities($entry->advisory_team);
			$a_de = ereg_replace("\n\n", "<br /><br />", htmlentities($entry->advisory_description));
			$a_st = htmlentities($entry->advisory_status);
			$a_co = htmlentities($entry->advisory_comment);
			$TABLE .= "<tr valign=\"top\"><td>$a_ti</td><td>$a_te</td><td class=\"desc\">$a_de</td><td>$a_st</td><td class=\"comment\">$a_co</td></tr>";
		}
		$TABLE .= "</table>";
		$CONTENT = "<h2>Advisories</h2><div>" . $TABLE;
		
	} else if ($PAGE == 'status') {
		$res = pg_query("select service_name from services order by service_name");
		$TABLE = "<table><tr><th>Team</th>";
		while($entry = pg_fetch_object($res)) {
			$s_name = htmlentities($entry->service_name);
			$TABLE .= "<th>$s_name</th>";
		}
		$TABLE .= "</tr>";
		$res = pg_query("select team_name from teams order by team_name");
		while($entry = pg_fetch_object($res)) {
			$s_team = htmlentities($entry->team_name);
			$TABLE .= "<tr><td>$s_team</td>";
			$res2 = pg_query_params("select status_text from states where status_team=$1 order by status_service", array($entry->team_name));
			while($entry2 = pg_fetch_object($res2)) {
				$s_text = htmlentities($entry2->status_text);
				$TABLE .= "<td>$s_text</td>";
			}
			$TABLE .= "</tr>";
		}
		$TABLE .= "</table>";
		$CONTENT = "<h2>Status</h2><div>" . $TABLE;
	}
	$CONTENT .= "</div>";

	$MY_ADDR = $_SERVER['HTTP_HOST'];

	$lupd = htmlentities(date("F d Y H:i:s", time()));

	$INFO = <<<EOF
	<div>
		<p>
			To report flags and/or report advisories, telnet to $MY_ADDR, port 8080. Follow the instructions given there!
		</p>
		<p>
			Last updated $lupd
		</p>
	</div>
EOF;

echo <<<EOF
$HEADER
<head><title>Scoring bot</title>
<link rel="stylesheet" type="text/css" href="ctf.css" />
</head>
<body>
<div class="main">
<div class="cnt">
<h1>$TITLE</h1>
<h2>Navigation</h2>
<div><p><a href="index.html">flags</a> -- <a
href="adv.html">advisories</a> -- <a href="status.html">status</a></p></div>
$CONTENT
<h2>Reporting flags and advisories</h2>
$INFO
$FOOTER
EOF;
?>
